VERSION 5.00
Begin VB.Form frmSaveAsDXF 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Save As CGM"
   ClientHeight    =   4896
   ClientLeft      =   1992
   ClientTop       =   1452
   ClientWidth     =   6900
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4896
   ScaleWidth      =   6900
   Begin VB.Frame Frame3 
      Caption         =   "Current Directory"
      Height          =   555
      Left            =   1920
      TabIndex        =   16
      Top             =   3060
      Width           =   4815
      Begin VB.Label lblPath 
         Caption         =   "Label3"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   240
         Width           =   4575
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Instructions"
      Height          =   990
      Left            =   120
      TabIndex        =   13
      Top             =   3720
      Width           =   5310
      Begin VB.Label lblInstructions2 
         Caption         =   "lblInstructions2"
         Height          =   255
         Left            =   120
         TabIndex        =   15
         Top             =   540
         Width           =   5055
      End
      Begin VB.Label lblInstructions1 
         Caption         =   "lblInstructions1"
         Height          =   225
         Left            =   120
         TabIndex        =   14
         Top             =   300
         Width           =   5055
      End
   End
   Begin VB.FileListBox filList 
      Height          =   1416
      Left            =   120
      Pattern         =   "*.dft"
      TabIndex        =   12
      Top             =   6600
      Visible         =   0   'False
      Width           =   2535
   End
   Begin VB.DirListBox dirList 
      Height          =   1605
      Left            =   3360
      TabIndex        =   11
      Top             =   6600
      Visible         =   0   'False
      Width           =   2955
   End
   Begin VB.Frame Frame1 
      Caption         =   " Process Method "
      Height          =   1935
      Left            =   4680
      TabIndex        =   7
      Top             =   360
      Width           =   2055
      Begin VB.OptionButton optAllFiles 
         Caption         =   "All Dft files in directory and subdirectories."
         Height          =   495
         Left            =   120
         TabIndex        =   10
         Top             =   1200
         Width           =   1875
      End
      Begin VB.OptionButton optAllInDirectory 
         Caption         =   "All dft files in directory."
         Height          =   495
         Left            =   120
         TabIndex        =   9
         Top             =   720
         Width           =   1875
      End
      Begin VB.OptionButton optSelected 
         Caption         =   "Selected Dft files."
         Height          =   495
         Left            =   120
         TabIndex        =   8
         Top             =   240
         Value           =   -1  'True
         Width           =   1875
      End
   End
   Begin VB.CommandButton cmdProcess 
      Caption         =   "Process"
      Height          =   375
      Left            =   5640
      TabIndex        =   6
      Top             =   3840
      Width           =   1095
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5640
      TabIndex        =   5
      Top             =   4320
      Width           =   1095
   End
   Begin VB.DirListBox dirDirectory 
      Height          =   2730
      Left            =   1920
      TabIndex        =   2
      Top             =   240
      Width           =   2595
   End
   Begin VB.FileListBox filFiles 
      Height          =   3144
      Left            =   60
      MultiSelect     =   2  'Extended
      Pattern         =   "*.dft"
      TabIndex        =   1
      Top             =   240
      Width           =   1635
   End
   Begin VB.DriveListBox drvDrive 
      Height          =   315
      Left            =   4680
      TabIndex        =   0
      Top             =   2640
      Width           =   2055
   End
   Begin VB.Label Label2 
      Caption         =   "Directories:"
      Height          =   255
      Left            =   1920
      TabIndex        =   4
      Top             =   0
      Width           =   1635
   End
   Begin VB.Label Label1 
      Caption         =   "Draft Files:"
      Height          =   255
      Left            =   60
      TabIndex        =   3
      Top             =   0
      Width           =   1635
   End
End
Attribute VB_Name = "frmSaveAsDXF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCancel_Click()
    End
End Sub

Private Sub cmdProcess_Click()
    Dim i As Integer
    Dim objApp As Object
    Dim objDoc As Object
    Dim objSheets As Object
    Dim objSheet As Object
    Dim blnCreated As Boolean
    Dim strFileNames() As String
    Dim intFileNameCount As Integer
    Dim newname As String
    Dim FieldCount As Integer
    Dim Fields(1 To 20) As String
    Dim SheetCount As Integer
    Dim SheetNumber As Integer

        

' Initialize flag to indicate if the user wants to stop processing files.
StopProcess = False
        
' Build up list of files to process depending on which option was selected.
intFileNameCount = 0
If filFiles.ListCount > 0 Or optAllFiles Then
  If optSelected Then
    ' Only process the selected files so build up the array so it
    ' contains the currently selected files.
            
    ' Allocate space to store the filenames.  This will allocate a little
    ' extra, but it's quick and easy and doesn't hurt anything.
    ReDim strFileNames(1 To filFiles.ListCount)
            
    ' Load the selected filenames into the array.
    For i = 0 To filFiles.ListCount - 1
      If filFiles.Selected(i) Then
        intFileNameCount = intFileNameCount + 1
        strFileNames(intFileNameCount) = filFiles.Path & "\" & filFiles.List(i)
      End If
    Next
  ElseIf optAllInDirectory Then
    ' Process all the files in the current directory.
            
    ' Allocate space to store the filenames.
    ReDim strFileNames(1 To filFiles.ListCount)
            
    ' Load the selected filenames into the array.
    For i = 0 To filFiles.ListCount - 1
      intFileNameCount = intFileNameCount + 1
      strFileNames(intFileNameCount) = filFiles.Path & "\" & filFiles.List(i)
    Next
  ElseIf optAllFiles Then
    ' Process all files in the current directory and subdirectories.
    Status "Creating list of files to process ...", dirDirectory.Path & "*.*"
    Call ReadFileNamesFromDirectory(dirDirectory.Path, intFileNameCount, strFileNames)
        
    DoEvents
    If StopProcess Then
      MsgBox "Processing aborted."
      GoTo RegularEnd
    End If
  End If
End If
     
' Check to be sure at least one draft file has been specified.
If intFileNameCount = 0 Then
  If optAllFiles Then
    ' Turn off the display of the status dialog.
    Status
  End If
        
  If optSelected Then
    MsgBox "No draft files are selected."
  ElseIf optAllInDirectory Then
    MsgBox "No draft files exist in the directory specified."
  ElseIf optAllFiles Then
    MsgBox "No draft files exist in the directories specified."
  End If
  Exit Sub
End If
        
' Turn off the form.
frmSaveAsDXF.Visible = False
         
' Turn on error trapping.
On Error Resume Next
    
' Attempt to connect to a running instance of Solid Edge.
Set objApp = GetObject(, "SolidEdge.Application")
If Err Then
  Status "Starting Solid Edge ...", ""
  ' Solid Edge is not running.  Clear the previous error.
  Err.Clear
        
  ' Start Solid Edge.
  Set objApp = CreateObject("SolidEdge.Application")
        
  ' Cannot start Solid Edge, so exit the program.
  If Err Then
    MsgBox "Cannot start Solid Edge."
    End
  End If
        
  ' Set flag to indicate this program started Solid Edge.
  blnCreated = True
        
  ' Make Solid Edge visible.
  objApp.Visible = True
Else
  ' Set flag to indicate Solid Edge was already running.
  blnCreated = False
End If

' Loop through files in file list control.
On Error GoTo ErrorFound
For i = 1 To intFileNameCount
  ' Check the global variable to see if the stop process command button has been selected
  DoEvents
  If StopProcess Then
    MsgBox "Processing aborted."
    GoTo RegularEnd
  End If
      
  ' Display current status
  Status "Processing file " & i & " of " & intFileNameCount & ":", strFileNames(i)
      
  ' Open the document.
  Set objDoc = objApp.Documents.Open(strFileNames(i))
  
  'Set object variable to sheets collection
  Set objSheets = objDoc.Sections(1).Sheets
  
  ' Save the number of active sheets to a variable
  SheetCount = objSheets.Count
  
  If SheetCount = 1 Then 'Only one sheet in the document
    ' Build up file name for output DXF file.
    newname = Left((strFileNames(i)), Len(strFileNames(i)) - 4) & ".DXF"
  
    ' Check to see if the file already exists and delete it if it does.
    If Dir(newname) <> "" Then
      Kill newname
    End If
        
    ' Save the new file.
    Call objDoc.SaveAs(newname)
    
  Else 'Multiple sheets in the document
    For SheetNumber = 1 To SheetCount
      Set objSheet = objDoc.Sections(1).Sheets(SheetNumber)
      objSheet.Activate
      ' Build up file name for output DXF file.
      newname = Left((strFileNames(i)), Len(strFileNames(i)) - 4) & "_" & SheetNumber & ".DXF"
  
      'Check to see if the file already exists and delete it if it does.
      If Dir(newname) <> "" Then
        Kill newname
      End If
    
      Call objDoc.SaveAs(newname)
      
    Next 'Sheet
  End If
  
  ' Close the document
  objDoc.Close False
        
  Set objDoc = Nothing
Next 'File
    
RegularEnd:
  ' Dismiss the status form.
  Status
    
  ' If this program started Solid Edge, quit Solid Edge.
  If blnCreated Then
    objApp.Quit
    Set objApp = Nothing
  End If
    
  frmSaveAsDXF.Visible = True
  Exit Sub

ErrorFound:
  ' Dismiss the status form.
  Status
    
  ' Display error message
  MsgBox "An error has occurred.  Processing has been stopped." & "(" & Err.Description & ")"

  ' If this program started Solid Edge, quit Solid Edge.
  If blnCreated Then
    objApp.Quit
    Set objApp = Nothing
  End If
    
  frmSaveAsDXF.Visible = True
  Exit Sub
End Sub

Private Sub dirDirectory_Change()
    filFiles.Path = dirDirectory.Path
    lblPath.Caption = dirDirectory.Path
End Sub

Private Sub drvDrive_Change()
    dirDirectory.Path = drvDrive.Drive
End Sub

Private Sub Form_Load()

lblInstructions1.Caption = "Select the directory containing the draft files, select the files required"
lblInstructions2.Caption = "or change the process method, and click the Process button."

lblPath.Caption = dirDirectory.Path

End Sub
' Recursively travels through a directory structure saving all files into an array.
Private Sub ReadFileNamesFromDirectory(ByVal FilePath As String, intFileNameCount As Integer, strFileNames() As String)
    Dim i As Integer
    Dim strDirList() As String
    Dim intDirCount As Integer
    
    ' Uses a directory and file list control to get a listing of files
    ' and directories for a specific directory.  Set the controls
    ' to point to the specified directory.
    dirList.Path = FilePath
    filList.Path = FilePath
    
    ' If there are any subdirectories in the current directory save their
    ' names in an array so they can be processed below.
    If dirList.ListCount > 0 Then
        ' Allocate memory to store the directories.
        ReDim strDirList(1 To dirList.ListCount)
        
        ' Set the counter.
        intDirCount = dirList.ListCount
        
        ' Save the directory names into the array.
        For i = 0 To dirList.ListCount - 1
            strDirList(i + 1) = dirList.List(i)
        Next
    End If
    
    ' If there are any files in the current directory save their names
    ' into the filename array.
    If filList.ListCount > 0 Then
        ' Allocate more space in the filename array to store the filenames.
        ReDim Preserve strFileNames(1 To intFileNameCount + filList.ListCount)
        
        ' Save all the filenames of the files in the current directory
        ' into the filename array.
        For i = 0 To filList.ListCount - 1
            intFileNameCount = intFileNameCount + 1
            strFileNames(intFileNameCount) = filList.Path & "\" & filList.List(i)
        Next
    End If
    
    ' Loop through subdirectories of the current directory and get their files.
    For i = 1 To intDirCount
        ' Recursively call this subroutine.
        Call ReadFileNamesFromDirectory(strDirList(i), intFileNameCount, strFileNames)
    Next
End Sub
